ForwardingSortedSet
Date: 2016-05-24

com.google.common.collect

## Class ForwardingSortedSet<E>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingCollection<E>
    - - com.google.common.collect.ForwardingSet<E>
      - - com.google.common.collect.ForwardingSortedSet<E>

- All Implemented Interfaces:
    java.lang.Iterable<E>, java.util.Collection<E>, java.util.Set<E>, java.util.SortedSet<E>
  Direct Known Subclasses:
    ForwardingNavigableSet

      @GwtCompatible
      public abstract class ForwardingSortedSet<E>
      extends ForwardingSet<E>
      implements java.util.SortedSet<E>

  A sorted set which forwards all its method calls to another sorted set. Subclasses should override one or more methods to modify the behavior of the backing sorted set as desired per the decorator pattern.

  Warning: The methods of `ForwardingSortedSet` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingCollection.add(E)` alone will not change the behavior of `ForwardingCollection.addAll(java.util.Collection<? extends E>)`, which can lead to unexpected behavior. In this case, you should override `addAll` as well, either providing your own implementation, or delegating to the provided `standardAddAll` method.

  Each of the `standard` methods, where appropriate, uses the set's comparator (or the natural ordering of the elements, if there is no comparator) to test element equality. As a result, if the comparator is not consistent with equals, some of the standard implementations may violate the `Set` contract.

  The `standard` methods and the collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingSortedSet()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Comparator<? super E>` | `comparator()`
    `protected abstract java.util.SortedSet<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `E` | `first()`
    `java.util.SortedSet<E>` | `headSet(E toElement)`
    `E` | `last()`
    `protected boolean` | `standardContains(java.lang.Object object)` A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of the `first()` method of `tailSet(E)`.
    `protected boolean` | `standardRemove(java.lang.Object object)` A sensible definition of `ForwardingCollection.remove(java.lang.Object)` in terms of the `iterator()` method of `tailSet(E)`.
    `protected java.util.SortedSet<E>` | `standardSubSet(E fromElement, E toElement)` A sensible default implementation of `subSet(Object, Object)` in terms of `headSet(Object)` and `tailSet(Object)`.
    `java.util.SortedSet<E>` | `subSet(E fromElement, E toElement)`
    `java.util.SortedSet<E>` | `tailSet(E fromElement)`

    - ### Methods inherited from class com.google.common.collect.ForwardingSet

      `equals, hashCode, standardEquals, standardHashCode, standardRemoveAll`

    - ### Methods inherited from class com.google.common.collect.ForwardingCollection

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardAddAll, standardClear, standardContainsAll, standardIsEmpty, standardRetainAll, standardToArray, standardToArray, standardToString, toArray, toArray`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Constructor Detail

    - #### ForwardingSortedSet

          protected ForwardingSortedSet()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract java.util.SortedSet<E> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingSet<E>`

    - #### comparator

          public java.util.Comparator<? super E> comparator()

      Specified by:
        `comparator` in interface `java.util.SortedSet<E>`

    - #### first

          public E first()

      Specified by:
        `first` in interface `java.util.SortedSet<E>`

    - #### headSet

          public java.util.SortedSet<E> headSet(E toElement)

      Specified by:
        `headSet` in interface `java.util.SortedSet<E>`

    - #### last

          public E last()

      Specified by:
        `last` in interface `java.util.SortedSet<E>`

    - #### subSet

          public java.util.SortedSet<E> subSet(E fromElement,
                                      E toElement)

      Specified by:
        `subSet` in interface `java.util.SortedSet<E>`

    - #### tailSet

          public java.util.SortedSet<E> tailSet(E fromElement)

      Specified by:
        `tailSet` in interface `java.util.SortedSet<E>`

    - #### standardContains

          @Beta
          protected boolean standardContains(@Nullable
                                      java.lang.Object object)

      A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of the `first()` method of `tailSet(E)`. If you override `tailSet(E)`, you may wish to override `ForwardingCollection.contains(java.lang.Object)` to forward to this implementation.
      Overrides:
        `standardContains` in class `ForwardingCollection<E>`
      Since:
        7.0

    - #### standardRemove

          @Beta
          protected boolean standardRemove(@Nullable
                                    java.lang.Object object)

      A sensible definition of `ForwardingCollection.remove(java.lang.Object)` in terms of the `iterator()` method of `tailSet(E)`. If you override `tailSet(E)`, you may wish to override `ForwardingCollection.remove(java.lang.Object)` to forward to this implementation.
      Overrides:
        `standardRemove` in class `ForwardingCollection<E>`
      Since:
        7.0

    - #### standardSubSet

          @Beta
          protected java.util.SortedSet<E> standardSubSet(E fromElement,
                                                   E toElement)

      A sensible default implementation of `subSet(Object, Object)` in terms of `headSet(Object)` and `tailSet(Object)`. In some situations, you may wish to override `subSet(Object, Object)` to forward to this implementation.
      Since:
        7.0